;**********************************************************
;
;
;
;                                            HIDEYUKI.ABE
;
;
;
;*******************************************************
;******************************************************
(defun break(s)
   (princ "BREAK>> (stop with <Enter>)\nBREAK>> ")(princ s)
   (while (/= (setq s (getstring "\nBREAK>> ")) "")
   (print (eval (read s))))   
)
;*******************************************************
(defun ab_error (msg)
   (prompt msg)
   (setvar "cmdecho" cm)
   (setq *error* ab_errorb)  
)
;**********************************************************
(defun C:do2( / )
   (setq ab_errorb *error*)
   (setq *error* ab_error)
   (setq cm (getvar "cmdecho"))
   ;(setvar "cmdecho" 0)
   (setq os (getvar "osmode"))
   (setvar "osmode" 0)
   (command "undo" "be")
   ;***************************************
   (setq la_list '() la_ent (tblnext "layer" ""));layer_list
   (while la_ent 
      (setq la_name (cdr (assoc 2 la_ent)))
      (setq la_list (append la_list (list la_name)))
      (setq la_ent (tblnext "layer"))
   )
   (setq la_list (acad_strlsort la_list));Xg\[g
   (setq exit_dialog 2 la_list_val nil)
      (while (> exit_dialog 1)
      (setq dcl_id (load_dialog "do2"))
      (if (not (new_dialog "do2"  dcl_id))(exit))
      (start_list "la_list")
      (mapcar 'add_list la_list)
      (end_list)
      (if la_list_val (set_tile "la_list" la_list_val )) 
      (action_tile  "la_list"  "(setq la_list_val $value)" )
      (action_tile  "top"  "(done_dialog 2)" )
      (action_tile  "up"  "(done_dialog 3)" )
      (action_tile  "revs"  "(done_dialog 4)" )
      (action_tile  "down"  "(done_dialog 5)" )
      (action_tile  "under"  "(done_dialog 6)" )
      (action_tile  "accept"  "(done_dialog 1)" )
      (action_tile  "cancel"  "(done_dialog)" )
      (setq exit_dialog (start_dialog))
      (cond
         ((= exit_dialog 2)
            (setq la_list (cons(nth (atoi la_list_val)la_list)(list_erase la_list_val la_list))
               la_list_val "0"
            )
         )
         ((= exit_dialog 3)
            (if (/= la_list_val "0")
               (setq la_list (list_change la_list_val la_list)
                  la_list_val (itoa  (1- (atoi la_list_val)))
               )
            )
         )
         ((= exit_dialog 4)(setq la_list(reverse la_list)))
         ((= exit_dialog 5)
            (if (/= la_list_val (itoa (1-(length la_list))))
               (setq la_list (list_change (itoa (1+ (atoi la_list_val))) la_list)
                  la_list_val (itoa  (1+ (atoi la_list_val)))
               )
            )
         )
         ((= exit_dialog 6)
            (setq la_list (append (list_erase la_list_val la_list)(list (nth (atoi la_list_val)la_list)))
               la_list_val (itoa (1- (length la_list)))
            )
         )
         
      )
   )
   (unload_dialog dcl_id)
   (if (/= exit_dialog 0)(progn
      (setq i 0)
      (while (nth i la_list)
         (draworder_b (nth i la_list))
         (setq i (1+ i))
      )
      (command "regen")
   ))
   ;************܂***************************   
   ;(command "undo" "e")
   ;(setvar "cmdecho" cm)
   ;(setvar "osmode" os)
   ;(setq *error* ab_errorb)
   (PRINC)
)
;***************************************
;la_name = Ŕwʂɂw
;la_name Ŏw肳ꂽwĔwʂɂ
(defun draworder_b(do_la_name / do_la_name )
   (if (ssget "x"(list (cons 8 do_la_name)))
   (command "_draworder" (ssget "x"(list (cons 8 do_la_name))) "" "B"))
) 
;***************************************
;list_number = list_in= ؽ list_out =ؽČ
;list_numberŎw肳ꂽؽčs̍sƓւ
;
(defun list_change( list_number list_in / num ko list_in list_out )
   (setq num (1-(atoi list_number)) ko 0)
   (while (nth ko list_in)
      (if (= ko num)(setq list_out (cons (nth (1+ ko) list_in) list_out)
      list_out (cons (nth ko list_in)list_out) ko (+ ko 2))
      (setq list_out (cons (nth ko list_in)list_out ) ko (1+ ko))
   )
)
(reverse list_out)
)
;***************************************
;list_number = list_in= ؽ list_out =ؽČ
;list_numberŎw肳ꂽؽčs폜
;
(defun list_erase( list_number list_in / ko list_in list_out )
(setq ko 0)
(while (nth ko list_in)
   (if (/= ko (atoi list_number))(setq list_out (cons (nth ko list_in)list_out )))
   (setq ko (1+ ko))
)
(reverse list_out)
)
;***************************************
(princ)